//============================================================================
// Pixel Gauges by Shaz
// Ver 1.00
// Shaz_PixelGauges.js
//============================================================================

var Imported = Imported || {};
Imported.Shaz_PixelGauges = true;

var Shaz = Shaz || {};
Shaz.PG = Shaz.PG || {};
Shaz.PG.Version = 1.00;

//=============================================================================
 /*:
 * @plugindesc Build gauges from pre-rendered images
 * @author Shaz
 *
 * @param Global
 *
 * @param Text in Front
 * @parent Global
 * @type boolean
 * @default true
 * 
 * @param Gauges
 *
 *
 * @param Background
 * @parent Gauges
 *
 * @param BGImage
 * @parent Background
 * @text Image (img/system/)
 * @type file
 * @dir img/system/
 * @require 1
 * @default mt
 *
 * @param BGWidth
 * @parent Background
 * @text Width
 * @type number
 * @min 1
 * @default 186
 *
 * @param BGHeight
 * @parent Background
 * @text Height
 * @type number
 * @min 1
 * @default 18
 *
 * @param BGLeftWidth
 * @parent Background
 * @text Left Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param BGRightWidth
 * @parent Background
 * @text Right Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param BGYOffset
 * @parent Background
 * @text Y Offset
 * @type number
 * @min -100
 * @default -10
 *
 *
 * @param HP
 * @parent Gauges
 *
 * @param HPImage
 * @parent HP
 * @text Image (img/system/)
 * @type file
 * @dir img/system/
 * @require 1
 * @default hp
 *
 * @param HPWidth
 * @parent HP
 * @text Width
 * @type number
 * @min 1
 * @default 186
 *
 * @param HPHeight
 * @parent HP
 * @text Height
 * @type number
 * @min 1
 * @default 18
 *
 * @param HPLeftWidth
 * @parent HP
 * @text Left Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param HPRightWidth
 * @parent HP
 * @text Right Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param HPYOffset
 * @parent HP
 * @text Y Offset
 * @type number
 * @min -100
 * @default -10
 *
 *
 * @param MP
 * @parent Gauges
 *
 * @param MPImage
 * @parent MP
 * @text Image (img/system/)
 * @type file
 * @dir img/system/
 * @require 1
 * @default mp
 *
 * @param MPWidth
 * @parent MP
 * @text Width
 * @type number
 * @min 1
 * @default 186
 *
 * @param MPHeight
 * @parent MP
 * @text Height
 * @type number
 * @min 1
 * @default 18
 *
 * @param MPLeftWidth
 * @parent MP
 * @text Left Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param MPRightWidth
 * @parent MP
 * @text Right Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param MPYOffset
 * @parent MP
 * @text Y Offset
 * @type number
 * @min -100
 * @default -10
 *
 *
 * @param TP
 * @parent Gauges
 *
 * @param TPImage
 * @parent TP
 * @text Image (img/system/)
 * @type file
 * @dir img/system/
 * @require 1
 * @default tp
 *
 * @param TPWidth
 * @parent TP
 * @text Width
 * @type number
 * @min 1
 * @default 186
 *
 * @param TPHeight
 * @parent TP
 * @text Height
 * @type number
 * @min 1
 * @default 18
 *
 * @param TPLeftWidth
 * @parent TP
 * @text Left Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param TPRightWidth
 * @parent TP
 * @text Right Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param TPYOffset
 * @parent TP
 * @text Y Offset
 * @type number
 * @min -100
 * @default -10
 *
 *
 * @param Exp
 * @parent Gauges
 *
 * @param ExpImage
 * @parent Exp
 * @text Image (img/system/)
 * @type file
 * @dir img/system/
 * @require 1
 * @default exp
 *
 * @param ExpWidth
 * @parent Exp
 * @text Width
 * @type number
 * @min 1
 * @default 186
 *
 * @param ExpHeight
 * @parent Exp
 * @text Height
 * @type number
 * @min 1
 * @default 18
 *
 * @param ExpLeftWidth
 * @parent Exp
 * @text Left Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param ExpRightWidth
 * @parent Exp
 * @text Right Width
 * @type number
 * @min 1
 * @default 18
 *
 * @param ExpYOffset
 * @parent Exp
 * @text Y Offset
 * @type number
 * @min -100
 * @default -10
 *
 *
 * @help This plugin has no plugin commands
 */

//=============================================================================

Shaz.Parameters = PluginManager.parameters('Shaz_PixelGauges');
Shaz.Param = Shaz.Param || {};
Shaz.Param.PG = Shaz.Param.PG || {};

Shaz.Param.PG.TextInFront = eval(Shaz.Parameters['Text in Front']);

Shaz.Param.PG.BG = {};
Shaz.Param.PG.BG.Image = String(Shaz.Parameters['BGImage']);
Shaz.Param.PG.BG.Width = Number(Shaz.Parameters['BGWidth']);
Shaz.Param.PG.BG.Height = Number(Shaz.Parameters['BGHeight']);
Shaz.Param.PG.BG.LeftWidth = Number(Shaz.Parameters['BGLeftWidth']);
Shaz.Param.PG.BG.RightWidth = Number(Shaz.Parameters['BGRightWidth']);
Shaz.Param.PG.BG.YOffset = Number(Shaz.Parameters['BGYOffset']);
Shaz.Param.PG.BG.x1 = Shaz.Param.PG.BG.LeftWidth;
Shaz.Param.PG.BG.w = Shaz.Param.PG.BG.Width - Shaz.Param.PG.BG.LeftWidth - Shaz.Param.PG.BG.RightWidth;
Shaz.Param.PG.BG.x2 = Shaz.Param.PG.BG.x1 + Shaz.Param.PG.BG.w;

Shaz.Param.PG.HP = {};
Shaz.Param.PG.HP.Image = String(Shaz.Parameters['HPImage']);
Shaz.Param.PG.HP.Width = Number(Shaz.Parameters['HPWidth']);
Shaz.Param.PG.HP.Height = Number(Shaz.Parameters['HPHeight']);
Shaz.Param.PG.HP.LeftWidth = Number(Shaz.Parameters['HPLeftWidth']);
Shaz.Param.PG.HP.RightWidth = Number(Shaz.Parameters['HPRightWidth']);
Shaz.Param.PG.HP.YOffset = Number(Shaz.Parameters['HPYOffset']);
Shaz.Param.PG.HP.x1 = Shaz.Param.PG.HP.LeftWidth;
Shaz.Param.PG.HP.w = Shaz.Param.PG.HP.Width - Shaz.Param.PG.HP.LeftWidth - Shaz.Param.PG.HP.RightWidth;
Shaz.Param.PG.HP.x2 = Shaz.Param.PG.HP.x1 + Shaz.Param.PG.HP.w;

Shaz.Param.PG.MP = {};
Shaz.Param.PG.MP.Image = String(Shaz.Parameters['MPImage']);
Shaz.Param.PG.MP.Width = Number(Shaz.Parameters['MPWidth']);
Shaz.Param.PG.MP.Height = Number(Shaz.Parameters['MPHeight']);
Shaz.Param.PG.MP.LeftWidth = Number(Shaz.Parameters['MPLeftWidth']);
Shaz.Param.PG.MP.RightWidth = Number(Shaz.Parameters['MPRightWidth']);
Shaz.Param.PG.MP.YOffset = Number(Shaz.Parameters['MPYOffset']);
Shaz.Param.PG.MP.x1 = Shaz.Param.PG.MP.LeftWidth;
Shaz.Param.PG.MP.w = Shaz.Param.PG.MP.Width - Shaz.Param.PG.MP.LeftWidth - Shaz.Param.PG.MP.RightWidth;
Shaz.Param.PG.MP.x2 = Shaz.Param.PG.MP.x1 + Shaz.Param.PG.MP.w;

Shaz.Param.PG.TP = {};
Shaz.Param.PG.TP.Image = String(Shaz.Parameters['TPImage']);
Shaz.Param.PG.TP.Width = Number(Shaz.Parameters['TPWidth']);
Shaz.Param.PG.TP.Height = Number(Shaz.Parameters['TPHeight']);
Shaz.Param.PG.TP.LeftWidth = Number(Shaz.Parameters['TPLeftWidth']);
Shaz.Param.PG.TP.RightWidth = Number(Shaz.Parameters['TPRightWidth']);
Shaz.Param.PG.TP.YOffset = Number(Shaz.Parameters['TPYOffset']);
Shaz.Param.PG.TP.x1 = Shaz.Param.PG.TP.LeftWidth;
Shaz.Param.PG.TP.w = Shaz.Param.PG.TP.Width - Shaz.Param.PG.TP.LeftWidth - Shaz.Param.PG.TP.RightWidth;
Shaz.Param.PG.TP.x2 = Shaz.Param.PG.TP.x1 + Shaz.Param.PG.TP.w;

Shaz.Param.PG.Exp = {};
Shaz.Param.PG.Exp.Image = String(Shaz.Parameters['ExpImage']);
Shaz.Param.PG.Exp.Width = Number(Shaz.Parameters['ExpWidth']);
Shaz.Param.PG.Exp.Height = Number(Shaz.Parameters['ExpHeight']);
Shaz.Param.PG.Exp.LeftWidth = Number(Shaz.Parameters['ExpLeftWidth']);
Shaz.Param.PG.Exp.RightWidth = Number(Shaz.Parameters['ExpRightWidth']);
Shaz.Param.PG.Exp.YOffset = Number(Shaz.Parameters['ExpYOffset']);
Shaz.Param.PG.Exp.x1 = Shaz.Param.PG.Exp.LeftWidth;
Shaz.Param.PG.Exp.w = Shaz.Param.PG.Exp.Width - Shaz.Param.PG.Exp.LeftWidth - Shaz.Param.PG.Exp.RightWidth;
Shaz.Param.PG.Exp.x2 = Shaz.Param.PG.Exp.x1 + Shaz.Param.PG.Exp.w;


var Shaz_PG_Scene_Boot_create = Scene_Boot.prototype.create;
Scene_Boot.prototype.create = function() {
	Shaz_PG_Scene_Boot_create.call(this);
	this.loadSystemGaugeImages();
};

Scene_Boot.prototype.loadSystemGaugeImages = function() {
	ImageManager.reserveSystem(Shaz.Param.PG.BG.Image);
	ImageManager.reserveSystem(Shaz.Param.PG.HP.Image);
	ImageManager.reserveSystem(Shaz.Param.PG.MP.Image);
	ImageManager.reserveSystem(Shaz.Param.PG.TP.Image);
	ImageManager.reserveSystem(Shaz.Param.PG.Exp.Image);
};

var Shaz_PG_Window_Base_initialize = Window_Base.prototype.initialize;
Window_Base.prototype.initialize = function(x, y, width, height) {
	Shaz_PG_Window_Base_initialize.call(this, x, y, width, height);
	this.loadGaugeImages();
};


Window_Base.prototype.loadGaugeImages = function() {
	this.gaugeImages = {};
	this.gaugeImages.BG = ImageManager.loadSystem(Shaz.Param.PG.BG.Image);
	this.gaugeImages.HP = ImageManager.loadSystem(Shaz.Param.PG.HP.Image);
	this.gaugeImages.MP = ImageManager.loadSystem(Shaz.Param.PG.MP.Image);
	this.gaugeImages.TP = ImageManager.loadSystem(Shaz.Param.PG.TP.Image);
	this.gaugeImages.Exp = ImageManager.loadSystem(Shaz.Param.PG.Exp.Image);
};

Window_Base.prototype.drawActorHp = function(actor, x, y, width) {
    width = width || 186;
    if (Shaz.Param.PG.TextInFront) {
	    this.drawPixelGauge(x, y, width, actor.hpRate(), 'HP');
	}
    this.changeTextColor(this.systemColor());
    this.drawText(TextManager.hpA, x, y, 44);
    this.drawCurrentAndMax(actor.hp, actor.mhp, x, y, width,
                           this.hpColor(actor), this.normalColor());
    if (!Shaz.Param.PG.TextInFront) {
	    this.drawPixelGauge(x, y, width, actor.hpRate(), 'HP');
	}
};

Window_Base.prototype.drawActorMp = function(actor, x, y, width) {
    width = width || 186;
    if (Shaz.Param.PG.TextInFront) {
    	this.drawPixelGauge(x, y, width, actor.mpRate(), 'MP');
    }
    this.changeTextColor(this.systemColor());
    this.drawText(TextManager.mpA, x, y, 44);
    this.drawCurrentAndMax(actor.mp, actor.mmp, x, y, width,
                           this.mpColor(actor), this.normalColor());
    if (!Shaz.Param.PG.TextInFront) {
    	this.drawPixelGauge(x, y, width, actor.mpRate(), 'MP');
    }
};

Window_Base.prototype.drawActorTp = function(actor, x, y, width) {
    width = width || 96;
    if (Shaz.Param.PG.TextInFront) {
    	this.drawPixelGauge(x, y, width, actor.tpRate(), 'TP');
    }
    this.changeTextColor(this.systemColor());
    this.drawText(TextManager.tpA, x, y, 44);
    this.changeTextColor(this.tpColor(actor));
    this.drawText(actor.tp, x + width - 64, y, 64, 'right');
    if (!Shaz.Param.PG.TextInFront) {
    	this.drawPixelGauge(x, y, width, actor.tpRate(), 'TP');
    }
};

Window_Base.prototype.drawExpGauge = function(x, y, width, rate, color1, color2) {
	this.drawPixelGauge(x, y, width, rate, 'Exp');
}

Window_Base.prototype.drawPixelGauge = function(x, y, width, rate, img) {
	this.drawGaugeLayer(x, y, width, 'BG');
	this.drawGaugeLayer(x, y, Math.floor(width * rate).clamp(0, width), img);
};

Window_Base.prototype.drawGaugeLayer = function(x, y, width, img) {
	var srcData = Shaz.Param.PG[img];
	var srcImg = this.gaugeImages[img];

	var gaugeImg = new Bitmap(this.contents.width, srcData.Height);
	for (gx = 0; gx < this.contents.width; gx += srcData.w) {
		gaugeImg.blt(srcImg, srcData.x1, 0, srcData.w, srcData.Height, gx, 0, srcData.w, srcData.Height);
	}
	gaugeImg.clearRect(0, 0, srcData.LeftWidth, srcData.Height);
	gaugeImg.clearRect(this.contents.width - srcData.RightWidth, 0, srcData.RightWidth, srcData.Height);
	gaugeImg.blt(srcImg, 0, 0, srcData.LeftWidth, srcData.Height, 0, 0, srcData.LeftWidth, srcData.Height);
	gaugeImg.blt(srcImg, srcData.x2, 0, srcData.RightWidth, srcData.Height, this.contents.width - srcData.RightWidth, 0, srcData.RightWidth, srcData.Height);

	var gaugeY = y + this.lineHeight() - 8 + srcData.YOffset;
	var left = Math.floor(width / 2);
	var right = width - left;

	this.contents.blt(gaugeImg, 0, 0, left, srcData.Height, x, gaugeY, left, srcData.Height);
	this.contents.blt(gaugeImg, this.contents.width - right, 0, right, srcData.Height, x + left, gaugeY, right, srcData.Height);
};